#pragma semicolon 1
//#pragma tabsize 0

#include <sourcemod>
#include <sourcebans>
#include <sdktools>
#undef REQUIRE_PLUGIN
#include <adminmenu>

#define MAX_STEAMID_LENGTH 32
#define MAX_IP_LENGTH 64

#define PREFIX "[Offline Ban]"
#define DEBUG 0

enum
{
	NAME = 0,
	IP,
	TIME
}

enum Target
{
	INDEX,
	T_iTime,
	String:T_sName[MAX_NAME_LENGTH],
	String:T_sReason[125]
}

new g_iTarget[MAXPLAYERS+1][Target];

new Handle:g_hData = INVALID_HANDLE,
	Handle:g_hSteamID = INVALID_HANDLE,
	Handle:g_hAdminMenu = INVALID_HANDLE,
	Handle:g_hDatabase,
	Handle:g_hHostIp,
	Handle:g_hPort;

new String:g_sServerIP[32], 
	String:g_sServerPort[8], 
	String:g_sLogFile[256],
	String:g_sDatabasePrefix[10] = "sb",
	String:g_sFormatTime[125],
	g_iMaxStoredPlayers,
	g_iMenuItems,
	bool:g_bMapClear = false,
	bool:g_bDelConPlayers = false,
	bool:g_bMenuNewLine = false;
	
new g_iServerID = -1;

new State:ConfigState;
new Handle:ConfigParser;
enum State /* ConfigState */
{
	ConfigStateNone = 0,
	ConfigStateConfig,
	ConfigStateReasons,
	ConfigStateTime,
	ConfigStateHacking
}

#define MAX_REASONS 64
#define DISPLAY_SIZE 64
#define REASON_SIZE 192

new iNumReasons,
	iNumHacking;
new String:g_sReasonDisplays[MAX_REASONS][DISPLAY_SIZE], 
	String:g_sReasonKey[MAX_REASONS][REASON_SIZE],
	String:g_sHackingDisplays[MAX_REASONS][DISPLAY_SIZE], 
	String:g_sHackingKey[MAX_REASONS][REASON_SIZE];

#define MAX_TIMES 32
#define TIME_SIZE 32
new iNumTimes;
new	String:g_sTimeDisplays[MAX_TIMES][DISPLAY_SIZE],
	String:g_sTimeMinutes[MAX_TIMES][DISPLAY_SIZE];

public Plugin:myinfo = 
{
	name = "Offline Ban list",
	author = "Grey™ & R1KO",
	description = "",
	version = "1.6",
	url = "hlmod.ru Skype: wolf-1-ser"
};

public OnPluginStart() 
{
	LoadTranslations("offlineban.phrases");
	
	new Handle:hCvar;
	
	HookConVarChange((hCvar = CreateConVar("sm_offban_timeformat", "%d.%m|%H:%M", "Формат вывода времени отключения\nOutput Format-off time")), FormatTimeChange);
	GetConVarString(hCvar, g_sFormatTime, sizeof(g_sFormatTime));
	
	HookConVarChange((hCvar = CreateConVar("sm_offban_max_stored", "21", "Максимальное количество игроков в истории\nMaximum number of players in history")), MaxStoredPlayersChange);
	g_iMaxStoredPlayers = GetConVarInt(hCvar);
	
	HookConVarChange((hCvar = CreateConVar("sm_offban_map_clear", "0", "Очищать ли историю игроков при смене карты\nWhether players clean history when the map changes")), MapClearChange);
	g_bMapClear = GetConVarBool(hCvar);
	
	HookConVarChange((hCvar = CreateConVar("sm_offban_del_con_players", "1", "Удалять ли из истории вновь подключившихся игроков\nWhether to delete the history of newly connected players")), DelConPlayersChange);
	g_bDelConPlayers = GetConVarBool(hCvar);

	HookConVarChange((hCvar = CreateConVar("sm_offban_menu_nast", "1", "1. name,time\n2. name,steam\n3. name,steam,time")), FormatItemsChange);
	g_iMenuItems = GetConVarInt(hCvar);
	
	HookConVarChange((hCvar = CreateConVar("sm_offban_menu_newline", "0", "Перенос строк в меню. 0 - выключено")), NewLineChange);
	g_bMenuNewLine = GetConVarBool(hCvar);
	
	CloseHandle(hCvar);
	
	RegAdminCmd("sm_offban_clear", CommandClearBan, ADMFLAG_ROOT, "Clear history");
	
	g_hData = CreateArray(125);
	g_hSteamID = CreateArray(MAX_STEAMID_LENGTH);

	BuildPath(Path_SM, g_sLogFile, sizeof(g_sLogFile), "logs/offlineban.log");

	SQL_TConnect(GotDatabase, "sourcebans");
	InsertServerInfo();
	
	new Handle:hTopmenu;
	if (LibraryExists("adminmenu") && ((hTopmenu = GetAdminTopMenu()) != INVALID_HANDLE)) 
		OnAdminMenuReady(hTopmenu);

	if(!SQL_CheckConfig("sourcebans"))
	{
		LogToFile(g_sLogFile, "Database failure: Could not find Database conf \"sourcebans\"");
		SetFailState("Database failure: Could not find Database conf \"sourcebans\"");
		return;
	}
	
	AutoExecConfig(true, "offlineban");
}

public FormatTimeChange(Handle:convar, const String:oldValue[], const String:newValue[]) 
	GetConVarString(convar, g_sFormatTime, sizeof(g_sFormatTime));
	
public MaxStoredPlayersChange(Handle:convar, const String:oldValue[], const String:newValue[]) 
	g_iMaxStoredPlayers = GetConVarInt(convar);
	
public MapClearChange(Handle:convar, const String:oldValue[], const String:newValue[]) 
	g_bMapClear = GetConVarBool(convar);
	
public DelConPlayersChange(Handle:convar, const String:oldValue[], const String:newValue[]) 
	g_bDelConPlayers = GetConVarBool(convar);
	
public FormatItemsChange(Handle:convar, const String:oldValue[], const String:newValue[]) 
	g_iMenuItems = GetConVarInt(convar);
	
public NewLineChange(Handle:convar, const String:oldValue[], const String:newValue[]) 
	g_bMenuNewLine = GetConVarBool(convar);

public Action:CommandClearBan(iClient, args)
{
	Clear_histories();
	
	PrintToChat(iClient, "%s %t", PREFIX, "Clear history");
}

public OnMapStart()
{ 
	ReadConfig();
	
	if(g_bMapClear) 
		Clear_histories();
}

off_RemoveFromArray(iIndex)
{
	RemoveFromArray(g_hData, iIndex);
	RemoveFromArray(g_hSteamID, iIndex);
}

Clear_histories()
{
	ClearArray(g_hData);
	ClearArray(g_hSteamID);
}

// удаление игроков вошедших в игру
public OnClientPostAdminCheck(iClient)
{
	if (!g_bDelConPlayers || !IsClientInGame(iClient) || IsFakeClient(iClient)) 
		return;

	decl String:sSteamID[MAX_STEAMID_LENGTH];
	GetClientAuthString(iClient, sSteamID, sizeof(sSteamID));
	new iIndex = FindStringInArray(g_hSteamID, sSteamID);
	if (iIndex != -1) 
	{
		off_RemoveFromArray(iIndex);
		#if DEBUG
			LogToFile(g_sLogFile,"Del: %s.", sSteamID);
		#endif
	}
}
 //зачисление в список игроков вышедших из игры
public OnClientDisconnect(iClient) 
{
	if (!IsClientInGame(iClient) || IsFakeClient(iClient)) 
		return;

	new AdminId:adminId = GetUserAdmin(iClient);
	if (adminId != INVALID_ADMIN_ID) 
	{
		if (GetAdminImmunityLevel(adminId) > 0) 
			return;
	}

	while (GetArraySize(g_hSteamID) >= g_iMaxStoredPlayers)
	{
		RemoveFromArray(g_hData, 0);
		RemoveFromArray(g_hSteamID, 0);
	}

	decl String:sSteamID[MAX_STEAMID_LENGTH],
		 String:sName[MAX_NAME_LENGTH],
		 String:sIP[MAX_IP_LENGTH],
		 Handle:hArray;

	GetClientAuthString(iClient, sSteamID, sizeof(sSteamID));
	PushArrayString(g_hSteamID, sSteamID);

	hArray = CreateArray(125);

	GetClientName(iClient, sName, sizeof(sName));
	PushArrayString(hArray, sName);
	GetClientIP(iClient, sIP, sizeof(sIP));
	PushArrayString(hArray, sIP);

	PushArrayCell(hArray, GetTime());
	PushArrayCell(g_hData, hArray);
	
#if DEBUG
	decl String:sTime[64];

	FormatTime(sTime, sizeof(sTime), g_sFormatTime, GetTime());
	LogToFile(g_sLogFile,"New: %s %s - %s ; %s.", sName, sSteamID, sIP, sTime);
#endif
}
//меню
public OnLibraryRemoved(const String:sName[]) 
{
	if (StrEqual(sName, "adminmenu")) 
		g_hAdminMenu = INVALID_HANDLE;
}

public OnAdminMenuReady(Handle:hTopmenu)
{
	if (hTopmenu == g_hAdminMenu)
		return;

	g_hAdminMenu = hTopmenu;
	new TopMenuObject:player_commands = FindTopMenuCategory(g_hAdminMenu, ADMINMENU_PLAYERCOMMANDS);
	if (player_commands != INVALID_TOPMENUOBJECT)
		AddToTopMenu(g_hAdminMenu, "OfflineBans", TopMenuObject_Item, AdminMenu_Ban, player_commands, "OfflineBans", ADMFLAG_BAN);
}

public AdminMenu_Ban(Handle:topmenu, TopMenuAction:action, TopMenuObject:object_id, iClient, String:buffer[], maxlength)
{
	switch(action)
	{
		case TopMenuAction_DisplayOption: FormatEx(buffer, maxlength, "%T", "OfflineBansTitle", iClient);
		case TopMenuAction_SelectOption: ShowBanList(iClient);
	}
}
//меню выбора игрока
ShowBanList(iClient) 
{
	new iSize = GetArraySize(g_hSteamID);
	if (iSize == 0) 
		PrintToChat(iClient, "%s %t", PREFIX, "No players history");
	else
	{
		new Handle:hMenu = CreateMenu(MenuHandler_BanList);
		decl String:sTitle[128],
			 String:sTitle2[128],
			 String:sName[MAX_NAME_LENGTH],
			 String:sSteamID[MAX_STEAMID_LENGTH],
			 String:sTime[64],
			 String:sIndex[5],
			 Handle:hArray;

		FormatEx(sTitle, sizeof(sTitle), "%T", "SelectPlayerTitle", iClient);
		SetMenuTitle(hMenu, sTitle);

		for (new i=iSize-1; i>=0; --i)
		{
			hArray = GetArrayCell(g_hData, i);
			GetArrayString(hArray, NAME, sName, sizeof(sName));
			GetArrayString(g_hSteamID, i, sSteamID, sizeof(sSteamID));
			FormatTime(sTime, sizeof(sTime), g_sFormatTime, GetArrayCell(hArray, TIME));
			
			if (g_bMenuNewLine)
			{
				switch(g_iMenuItems)
				{
					case 1:	FormatEx(sTitle, sizeof(sTitle), "%s", sTime);
					case 2: FormatEx(sTitle, sizeof(sTitle), "%s", sSteamID); 
					case 3: FormatEx(sTitle, sizeof(sTitle), "%s (%s)", sSteamID, sTime); 
				}
				FormatEx(sTitle2, sizeof(sTitle2), "%s\n(%s)", sName, sTitle); 
				IntToString(i, sIndex, sizeof(sIndex));
				AddMenuItem(hMenu, sIndex, sTitle2);
			}
			else
			{
				switch(g_iMenuItems)
				{
					case 1:	FormatEx(sTitle, sizeof(sTitle), "%s (%s)", sName, sTime);
					case 2: FormatEx(sTitle, sizeof(sTitle), "%s (%s)", sName, sSteamID); 
					case 3: FormatEx(sTitle, sizeof(sTitle), "%s - %s (%s)", sName, sSteamID, sTime); 
				}
				IntToString(i, sIndex, sizeof(sIndex));
				AddMenuItem(hMenu, sIndex, sTitle);
			}
			#if DEBUG
				ReplaceString(sTitle2, sizeof(sTitle2), "\n", " ");
				LogToFile(g_sLogFile,"Menu: %s - %s%s", sIndex, sTitle, sTitle2);
			#endif
		}

		SetMenuExitBackButton(hMenu, true);
		DisplayMenu(hMenu, iClient, MENU_TIME_FOREVER);
	}
}

public MenuHandler_BanList(Handle:hMenu, MenuAction:action, iClient, iSlot) 
{
	switch(action)
	{
		case MenuAction_End: 	CloseHandle(hMenu);
		case MenuAction_Cancel:
		{
			if (iSlot == MenuCancel_ExitBack && g_hAdminMenu != INVALID_HANDLE)
				DisplayTopMenu(g_hAdminMenu, iClient, TopMenuPosition_LastCategory);
		}
		case MenuAction_Select:
		{
			decl String:sIndex[5];
			GetMenuItem(hMenu, iSlot, sIndex, sizeof(sIndex));
			g_iTarget[iClient][INDEX] = StringToInt(sIndex);
			#if DEBUG
				LogToFile(g_sLogFile,"Menu BanList: %s", sIndex);
			#endif
			
			ShowBanTimeMenu(iClient);
		}
	}
}

//меню выбора времени бана
ShowBanTimeMenu(iClient)
{
	decl String:sName[MAX_NAME_LENGTH],
		 Handle:hArray;
	hArray = GetArrayCell(g_hData, g_iTarget[iClient][INDEX]);
	GetArrayString(hArray, NAME, sName, sizeof(sName));
	
	new Handle:hMenu = CreateMenu(MenuHandler_MenuTime);
	decl String:sTitle[128];
	FormatEx(sTitle, sizeof(sTitle), "%T - %s", "SelectTimeTitle", iClient, sName);
	SetMenuTitle(hMenu, sTitle);

	for (new i = 0; i <= iNumTimes; i++)
		AddMenuItem(hMenu, g_sTimeMinutes[i], g_sTimeDisplays[i]);

	SetMenuExitBackButton(hMenu, true);
	DisplayMenu(hMenu, iClient, MENU_TIME_FOREVER);
}

public MenuHandler_MenuTime(Handle:hMenu, MenuAction:action, iClient, iSlot) 
{
	switch(action)
	{
		case MenuAction_End: 	CloseHandle(hMenu);
		case MenuAction_Cancel:
		{
			if (iSlot == MenuCancel_ExitBack && g_hAdminMenu != INVALID_HANDLE)
				ShowBanList(iClient);
		}
		case MenuAction_Select:
		{
			decl String:sInfo[32];
			GetMenuItem(hMenu, iSlot, sInfo, sizeof(sInfo));
			g_iTarget[iClient][T_iTime] = StringToInt(sInfo);
			#if DEBUG
				LogToFile(g_sLogFile,"Menu Time: %s", sInfo);
			#endif
			
			ShowBanReasonMenu(iClient);
		}
	}
}

//меню выбора причины бана
ShowBanReasonMenu(iClient)
{
	decl String:sName[MAX_NAME_LENGTH],
		 Handle:hArray;
	hArray = GetArrayCell(g_hData, g_iTarget[iClient][INDEX]);
	GetArrayString(hArray, NAME, sName, sizeof(sName));
	
	new Handle:hMenu = CreateMenu(MenuHandler_MenuReason);
	decl String:sTitle[128];
	FormatEx(sTitle, sizeof(sTitle), "%T - %s", "SelectReasonTitle", iClient, sName);
	SetMenuTitle(hMenu, sTitle);

	for (new i = 0; i <= iNumReasons; i++)
		AddMenuItem(hMenu, g_sReasonKey[i], g_sReasonDisplays[i]);

	SetMenuExitBackButton(hMenu, true);
	DisplayMenu(hMenu, iClient, MENU_TIME_FOREVER);
}

public MenuHandler_MenuReason(Handle:hMenu, MenuAction:action, iClient, iSlot)
{
	switch(action)
	{
		case MenuAction_End: 	CloseHandle(hMenu);
		case MenuAction_Cancel:
		{
			if (iSlot == MenuCancel_ExitBack && g_hAdminMenu != INVALID_HANDLE)
				ShowBanTimeMenu(iClient);
		}
		case MenuAction_Select:
		{
			decl String:sInfo[128];
			GetMenuItem(hMenu, iSlot, sInfo, sizeof(sInfo));
			strcopy(g_iTarget[iClient][T_sReason], sizeof(sInfo), sInfo);
			#if DEBUG
				LogToFile(g_sLogFile,"Menu Reason: %s", sInfo);
			#endif
			
			if(StrEqual("Hacking", sInfo))
			{
				ShowBanHackingMenu(iClient);
				return;
			}
			CheckAdmins(iClient);
		}
	}
}

ShowBanHackingMenu(iClient)
{
	decl String:sName[MAX_NAME_LENGTH],
		 Handle:hArray;
	hArray = GetArrayCell(g_hData, g_iTarget[iClient][INDEX]);
	GetArrayString(hArray, NAME, sName, sizeof(sName));
	
	new Handle:hMenu = CreateMenu(MenuHandler_MenuHacking);
	decl String:sTitle[128];
	FormatEx(sTitle, sizeof(sTitle), "%T - %s", "SelectReasonTitle", iClient, sName);
	SetMenuTitle(hMenu, sTitle);

	for (new i = 0; i <= iNumHacking; i++)
		AddMenuItem(hMenu, g_sHackingKey[i], g_sHackingDisplays[i]);

	SetMenuExitBackButton(hMenu, true);
	DisplayMenu(hMenu, iClient, MENU_TIME_FOREVER);
}

public MenuHandler_MenuHacking(Handle:hMenu, MenuAction:action, iClient, iSlot)
{
	switch(action)
	{
		case MenuAction_End: 	CloseHandle(hMenu);
		case MenuAction_Cancel:
		{
			if (iSlot == MenuCancel_ExitBack && g_hAdminMenu != INVALID_HANDLE)
				ShowBanReasonMenu(iClient);
		}
		case MenuAction_Select:
		{
			decl String:sInfo[128];
			GetMenuItem(hMenu, iSlot, sInfo, sizeof(sInfo));
			strcopy(g_iTarget[iClient][T_sReason], sizeof(sInfo), sInfo);
			#if DEBUG
				LogToFile(g_sLogFile,"Menu Hacking: %s", sInfo);
			#endif

			CheckAdmins(iClient);
		}
	}
}

//проверка есть-ли админ в бд
stock CheckAdmins(iClient)
{
	decl String:sAdmin_SteamID[MAX_STEAMID_LENGTH],
		 String:sAdminIp[MAX_IP_LENGTH],
		 String:sQuery[1024];
		
	GetClientAuthString(iClient, sAdmin_SteamID, sizeof(sAdmin_SteamID));
		
	FormatEx(sQuery, sizeof(sQuery), "SELECT * FROM %s_admins WHERE `authid` = '%s'", 
			g_sDatabasePrefix, sAdmin_SteamID);
	new Handle:hQuery = SQL_Query(g_hDatabase, sQuery);

	if (g_hDatabase == INVALID_HANDLE)
	{
		LogToFile(g_sLogFile, "Database failure, Check Admins");
		return;
	}

	if (SQL_FetchRow(hQuery))
		GetClientIP(iClient, sAdminIp, sizeof(sAdminIp));
	else
	{
		strcopy(sAdmin_SteamID, sizeof(sAdmin_SteamID), "STEAM_ID_SERVER");
		strcopy(sAdminIp, sizeof(sAdminIp), g_sServerIP);
	}
#if DEBUG
	LogToFile(g_sLogFile,": %s", sQuery);
#endif
	CreateBanSB(iClient, sAdmin_SteamID, sAdminIp);
}
//занесение бана в бд
stock CreateBanSB(iClient, String:sAdmin_SteamID[], String:sAdminIp[])
{
	decl String:sAuth[MAX_STEAMID_LENGTH],
		 String:sIp[MAX_IP_LENGTH],
		 String:sBanName[MAX_NAME_LENGTH+32],
		 String:sReason[200],
		 String:sQuery[1024],
		 Handle:hArray;
		 
	hArray = GetArrayCell(g_hData, g_iTarget[iClient][INDEX]);
	GetArrayString(hArray, NAME, g_iTarget[iClient][T_sName], 64);
	GetArrayString(hArray, IP, sIp, sizeof(sIp));
	GetArrayString(g_hSteamID, g_iTarget[iClient][INDEX], sAuth, sizeof(sAuth));

	new iTime = g_iTarget[iClient][T_iTime]*60;
	
	SQL_EscapeString(g_hDatabase, g_iTarget[iClient][T_sName], sBanName, sizeof(sBanName));
#if DEBUG
	LogToFile(g_sLogFile,"name do %s : posle %s", g_iTarget[iClient][T_sName], sBanName);
#endif

	FormatEx(sReason, sizeof(sReason), "%s %s", PREFIX, g_iTarget[iClient][T_sReason]);

	if(g_iServerID == -1) FormatEx(sQuery, sizeof(sQuery), "INSERT INTO %s_bans (ip, authid, name, created, ends, length, reason, aid, adminIp, sid, country) VALUES \
			('%s', '%s', '%s', UNIX_TIMESTAMP(), UNIX_TIMESTAMP() + %d, %d, '%s', \
			(SELECT `aid` FROM %s_admins WHERE `authid` = '%s' LIMIT 0,1), '%s', \
			(SELECT `sid` FROM %s_servers WHERE `ip` = '%s' AND `port` = '%s' LIMIT 0,1), ' ')", 
			g_sDatabasePrefix, sIp, sAuth, sBanName, iTime, iTime, sReason, g_sDatabasePrefix, sAdmin_SteamID, sAdminIp, g_sDatabasePrefix, g_sServerIP, g_sServerPort);
	else FormatEx(sQuery, sizeof(sQuery), "INSERT INTO %s_bans (ip, authid, name, created, ends, length, reason, aid, adminIp, sid, country) VALUES \
			('%s', '%s', '%s', UNIX_TIMESTAMP(), UNIX_TIMESTAMP() + %d, %d, '%s', \
			(SELECT `aid` FROM %s_admins WHERE `authid` = '%s' LIMIT 0,1), '%s', \
			%d, ' ')", g_sDatabasePrefix, sIp, sAuth, sBanName, iTime, iTime, sReason, g_sDatabasePrefix, sAdmin_SteamID, sAdminIp, g_iServerID);
	CheckUTF8();
	SQL_TQuery(g_hDatabase, VerifyInsert, sQuery, iClient, DBPrio_High);
#if DEBUG
	LogToFile(g_sLogFile,": %s", sQuery);
#endif
	LogAction(iClient,-1, "\"%L\" banned \"%s (%s IP%s)\" (minutes \"%d\") (reason \"%s\")", iClient, g_iTarget[iClient][T_sName], sAuth, sIp, g_iTarget[iClient][T_iTime], g_iTarget[iClient][T_sReason]);

	return true;
}

public CheckUTF8()
{
	decl String:sQuery[64];
	FormatEx(sQuery, sizeof(sQuery), "SET NAMES 'utf8'");
	SQL_TQuery(g_hDatabase, ErrorCheckCallback, sQuery, any:0, DBPrio_High);
}

public GotDatabase(Handle:owner, Handle:hndl, const String:error[], any:data)
{
	if (hndl == INVALID_HANDLE)
	{
		LogToFile(g_sLogFile, "Database failure: %s", error);
		return;
	}
	
	g_hDatabase = hndl;

	decl String:sQuery[64];
	FormatEx(sQuery, sizeof(sQuery), "SET NAMES 'utf8'");
	SQL_TQuery(g_hDatabase, ErrorCheckCallback, sQuery);
}

public ErrorCheckCallback(Handle:owner, Handle:hndle, const String:error[], any:data)
{
	if(error[0])
		LogToFile(g_sLogFile, "Query Failed: %s", error);
}

public VerifyInsert(Handle:owner, Handle:hndl, const String:error[], any:iClient)
{
	decl String:sAuth[MAX_STEAMID_LENGTH];
	GetArrayString(g_hSteamID, g_iTarget[iClient][INDEX], sAuth, sizeof(sAuth));

	if (hndl == INVALID_HANDLE || error[0])
	{
		LogToFile(g_sLogFile, "Verify Insert Query Failed: %s", error);
		PrintToChat(iClient, "\x01%s \x07ff0033%t %s", PREFIX, "Failed to ban", g_iTarget[iClient][T_sName], sAuth);
		return;
	}
	else
	{
		PrintToChat(iClient, "\x01%s \x0734c924%t %s", PREFIX, "Added to ban", g_iTarget[iClient][T_sName], sAuth);	
		off_RemoveFromArray(g_iTarget[iClient][INDEX]);
	}
}

static InitializeConfigParser()
{
	if (ConfigParser == INVALID_HANDLE)
	{
		ConfigParser = SMC_CreateParser();
		SMC_SetReaders(ConfigParser, ReadConfig_NewSection, ReadConfig_KeyValue, ReadConfig_EndSection);
	}
}

static InternalReadConfig(const String:path[])
{
	ConfigState = ConfigStateNone;

	new SMCError:err = SMC_ParseFile(ConfigParser, path);

	if (err != SMCError_Okay)
	{
		decl String:sBuffer[64];
		if (SMC_GetErrorString(err, sBuffer, sizeof(sBuffer)))
		{
			PrintToServer(sBuffer);
			LogToFile(g_sLogFile, sBuffer);
		}
		else 
		{
			PrintToServer("Fatal parse error");
			LogToFile(g_sLogFile, "Fatal parse error");
		}
	}
}

public SMCResult:ReadConfig_NewSection(Handle:smc, const String:sName[], bool:opt_quotes)
{
	if(sName[0])
	{
		if(strcmp("Config", sName, false) == 0)
			ConfigState = ConfigStateConfig;
		else if(strcmp("BanTime", sName, false) == 0)
			ConfigState = ConfigStateTime;
		else if(strcmp("BanReasons", sName, false) == 0)
			ConfigState = ConfigStateReasons;
		else if(strcmp("HackingReasons", sName, false) == 0)
			ConfigState = ConfigStateHacking;
	}
	return SMCParse_Continue;
}

public SMCResult:ReadConfig_KeyValue(Handle:smc, const String:key[], const String:value[], bool:key_quotes, bool:value_quotes)
{
	if(!key[0])
		return SMCParse_Continue;

	switch(ConfigState)
	{
		case ConfigStateConfig:
		{
			if(strcmp("DatabasePrefix", key, false) == 0) 
			{
				strcopy(g_sDatabasePrefix, sizeof(g_sDatabasePrefix), value);

				if(g_sDatabasePrefix[0] == '\0')
					g_sDatabasePrefix = "sb";
			}
			else if(strcmp("ServerID", key, false) == 0)
				g_iServerID = StringToInt(value);
		}
		case ConfigStateTime:
		{
			strcopy(g_sTimeMinutes[iNumTimes], sizeof(g_sTimeMinutes[]), key);
			strcopy(g_sTimeDisplays[iNumTimes], sizeof(g_sTimeDisplays[]), value);
			#if DEBUG
				LogToFile(g_sLogFile,"Loaded time. iIndex %d, key \"%s\", display_text \"%s\"", iNumTimes, g_sTimeMinutes[iNumTimes], g_sTimeDisplays[iNumTimes]);
			#endif
			iNumTimes++;
		}
		case ConfigStateReasons:
		{
			strcopy(g_sReasonKey[iNumReasons], sizeof(g_sReasonKey[]), key);
			strcopy(g_sReasonDisplays[iNumReasons], sizeof(g_sReasonDisplays[]), value);
			#if DEBUG
				LogToFile(g_sLogFile,"Loaded reason. iIndex %d, key \"%s\", display_text \"%s\"", iNumReasons, g_sReasonKey[iNumReasons], g_sReasonDisplays[iNumReasons]);
			#endif
			iNumReasons++;
		}
		case ConfigStateHacking:
		{
			strcopy(g_sHackingKey[iNumHacking], sizeof(g_sHackingKey[]), key);
			strcopy(g_sHackingDisplays[iNumHacking], sizeof(g_sHackingDisplays[]), value);
			#if DEBUG
				LogToFile(g_sLogFile,"Loaded hacking reason. iIndex %d, key \"%s\", display_text \"%s\"", iNumHacking, g_sHackingKey[iNumHacking], g_sHackingDisplays[iNumHacking]);
			#endif
            iNumHacking++;
		}
	}
	return SMCParse_Continue;
}

public SMCResult:ReadConfig_EndSection(Handle:smc)
	return SMCParse_Continue;

stock ReadConfig()
{
	InitializeConfigParser();

	if (ConfigParser == INVALID_HANDLE)
		return;

	decl String:sConfigFile[PLATFORM_MAX_PATH];
	BuildPath(Path_SM, sConfigFile, sizeof(sConfigFile), "configs/sourcebans/sourcebans.cfg");

	if(FileExists(sConfigFile))
	{
		iNumReasons = 0;
		iNumHacking = 0;
		iNumTimes = 0;
		InternalReadConfig(sConfigFile);
		if (iNumReasons)
			iNumReasons--;
		if (iNumHacking)
			iNumHacking--;
		if (iNumTimes)
			iNumTimes--;
	}
	else 
	{
		decl String:sError[PLATFORM_MAX_PATH + 64];
		FormatEx(sError, sizeof(sError), "%sFATAL *** ERROR *** can not find %s", PREFIX, sConfigFile);
		LogToFile(g_sLogFile, "FATAL *** ERROR *** can not find %s", sConfigFile);
		SetFailState(sError);
	}
}

stock InsertServerInfo()
{
	new iPieces[4], 
		iLongIP;	
	g_hHostIp = FindConVar("hostip");
	g_hPort = FindConVar("hostport");
	
	iLongIP = GetConVarInt(g_hHostIp);
	iPieces[0] = (iLongIP >> 24) & 0x000000FF;
	iPieces[1] = (iLongIP >> 16) & 0x000000FF;
	iPieces[2] = (iLongIP >> 8) & 0x000000FF;
	iPieces[3] = iLongIP & 0x000000FF;
	FormatEx(g_sServerIP, sizeof(g_sServerIP), "%d.%d.%d.%d", iPieces[0], iPieces[1], iPieces[2], iPieces[3]);
	GetConVarString(g_hPort, g_sServerPort, sizeof(g_sServerPort));
}
